// brass.h -- klasy do obsługi rachunków
#ifndef BRASS_H_
#define BRASS_H_
#include <string>

// klasa do obsługi rachunku Brass
class Brass
{
    private:
        std::string fullName;
        long acctNum;
        double balance;
    public:
        Brass(const std::string & s = "brak", long an = -1,
                double bal = 0.0);
        void Deposit(double amt);
        virtual void Withdraw(double amt);
        double Balance() const;
        virtual void ViewAcct() const;
        virtual ~Brass() {}
};

// klasa do obsługi rachunku BrassPlus
class BrassPlus : public Brass
{
    private:
        double maxLoan;
        double rate;
        double owesBank;
    public:
        BrassPlus(const std::string & s = "brak", long an = -1,
                double bal = 0.0, double ml = 2000,
                double r = 0.11125);
        BrassPlus(const Brass & ba, double ml = 2000, double r = 0.11125);
        virtual void ViewAcct() const;
        virtual void Withdraw(double amt);
        void ResetMax(double m) { maxLoan = m; }
        void ResetRate(double r) { rate = r; }
        void ResetOwes() { owesBank = 0; }
};

#endif

